/*
	ProWesS, PROGS Windowing System
	PROforma, PROGS Font & Raster Manager

	PFconfig : utility program for ProWesS package
		allows easy configuration of PROforma

	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	21.10.1996 started
*/

#include "PFConfig.h"

/* === add an extra directory in the font path === */

static Error set(PWObject object)
{
	Global *g;
	char dir[IO_MAXDIRECTORY];
	char string[MAX_LINE];

	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	PWChange(object,PW_EDLINE_GET,IO_MAXDIRECTORY,dir,NULL);

	STRFormatPutSafe(string,MAX_LINE,"S +%s",dir);
	THINGCall(PF_THING_NAME,PF_THING_CNFG,1,string);

	return LineAdd(g,dir,&g->fpath);
}

Error FontPath(Global *g)
{
	Error err;
	PWObject obj;

	if (ERR_OK==(err=PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
					PW_OUTLINE_QUIT,
					PW_OUTLINE_QUIT_KEYPRESS, 27,
					PW_OUTLINE_TITLE_TEXT, "add dir in fontpath",
					PW_OUTLINE_HELP,
					PW_OUTLINE_HELP_DIRECTORY, "$PWSDIR_doc_",
					PW_OUTLINE_HELP_FILE, "PFconfig_html",
					PW_OUTLINE_HELP_POSITION, "sfont",
					NULL)))
		err=PWCreate(obj,NULL,PW_TYPE_DIRECT_EDLINE,
					PW_EDLINE_MAXLENGTH, IO_MAXDIRECTORY,
					PW_EDLINE_ACTION_AFTER, set,
					PW_GLOBAL_AUXILIARY, g,
					NULL);
	if (err) return DisplayError(err);
	err=PWActivate(obj);
	if (err) err=DisplayError(err);
	PWRemove(obj);

	return ERR_OK;
}
