/*
	test program for PROGS SMS C library

	tload : load a ProWesS type if it is not yet available
		needs a few parameters : id filename directory
		e.g. :	 tload LSEL listselect $PWfile-DIR

	written by Joachim Van der Auwera for PROGS
	(c) by PROGS, Professional & Graphical Software
	started 21 October 1997
*/

#include "sms.h"
#include "io.h"
#include "str.h"
#include "thing.h"
#include "ProWesS.h"	/* for PW_THING_CONFIG */

#define catch(X) do { if (err=(X)) return err; } while (0)

#define MAX 80

Error init(char *param)
{
	Error err=ERR_OK;
	char line[MAX];
	char **list;

	/* get the command line parameters */
	STRBreak(param,&list);

	/* skip -path parameter if it is present */
	if (STRSameCI(*list,"-path") && *(list+1)!=NULL) list+=2;

	/* check for correct nmber of parameters */
	if (*list==NULL || *(list+1)==NULL || *(list+2)==NULL) return ERR_ISYN;

	/* check whether type is already available */
	STRCopy("? ",line);
	STRAppendSafe(*list,line,MAX);
	err=THINGCall(PW_THING_NAME,PW_THING_CNFG,1,line);
	if (err)
	{
		STRCopy("T ",line);
		STRAppendSafe(*(list+1),line,MAX);
		err=THINGCall(PW_THING_NAME,PW_THING_CNFG,1,line);
		if (err)
		{
			STRCopy("T ",line);
			STRAppendSafe(*(list+2),line,MAX);
			if (line[strlen(line)-1]=='_')
				STRAppendSafe("_",line,MAX);
			STRAppendSafe(*(list+1),line,MAX);
			err=THINGCall(PW_THING_NAME,PW_THING_CNFG,1,line);
		}
	}
	return err;
}
